\begin{luacode*}
--*- Lua -*-

local XMP=[[
<?xpacket begin='<U+FEFF>' id='W5M0MpCehiHzreSzNTczkc9d'?>
<x:xmpmeta xmlns:x="adobe:ns:meta/" x:xmptk=''> 
<rdf:RDF xmlns:rdf = "http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<rdf:Description rdf:about="" xmlns:xmp="http://ns.adobe.com/xap/1.0/"> 
<xmp:CreatorTool>TeX</xmp:CreatorTool> 
<xmp:ModifyDate>@date@</xmp:ModifyDate> 
<xmp:CreateDate>@date@</xmp:CreateDate> 
<xmp:MetadataDate>@date@</xmp:MetadataDate> 
</rdf:Description> 
<rdf:Description rdf:about="" xmlns:pdf="http://ns.adobe.com/pdf/1.3/"> 
<pdf:Producer>LuaTeX-0.76.0</pdf:Producer>
<pdf:Keywords>pdfTeX, PDF/X-1a, PDF/A-1b</pdf:Keywords> 
</rdf:Description> 
<rdf:Description rdf:about="" xmlns:dc="http://purl.org/dc/elements/1.1/"> 
<dc:format>application/pdf</dc:format> 
<dc:title><rdf:Alt><rdf:li xml:lang="x-default">An Example Document</rdf:li></rdf:Alt></dc:title> 
<dc:creator><rdf:Seq><rdf:li>Reinhard</rdf:li></rdf:Seq></dc:creator> 
<dc:description><rdf:Alt><rdf:li xml:lang="x-default">ID1234ABC</rdf:li></rdf:Alt></dc:description> 
<dc:subject><rdf:Bag><rdf:li>pdfTeX</rdf:li>
     <rdf:li>PDF/X-1a</rdf:li>
     <rdf:li>PDF/A-1b</rdf:li></rdf:Bag></dc:subject> 
<dc:format>application/pdf</dc:format>
</rdf:Description> 
<rdf:Description rdf:about="" xmlns:pdfaid = "http://www.aiim.org/pdfa/ns/id/">
<pdfaid:part>1</pdfaid:part> 
<pdfaid:conformance>B</pdfaid:conformance> 
</rdf:Description> 
<rdf:Description rdf:about="" xmlns:xmpMM="http://ns.adobe.com/xap/1.0/mm/">
<xmpMM:DocumentID>uuid:a0f82b2d-8ea2-416a-8b4d-737bb32f2734</xmpMM:DocumentID>
<xmpMM:InstanceID>uuid:945aaa6c-659c-4110-b8be-9e5b761e2138</xmpMM:InstanceID>
</rdf:Description>
</rdf:RDF> 
</x:xmpmeta> 
<?xpacket end='w'?>
                                                       
                <!--                         -->

]]


function xmpdate (d)
  return d:gsub(
    "D:(....)(..)(..)(..)(..)(..)(...)'(..)'", '%1-%2-%3T%4:%5:%6%7:%8')
end

function XMPobj (cdate)
   XMP=XMP:gsub('<U%+FEFF>', '\xef\xbb\xbf')
   XMP=XMP:gsub('@date@', xmpdate(cdate))

   local cl=tex.pdfcompresslevel
   tex.pdfcompresslevel=0
   local xmpobj=pdf.immediateobj(
     'stream', 
     XMP,
     '/Type/Metadata/Subtype/XML')
   tex.pdfcompresslevel=cl
   
   local meta=string.format('/Metadata %d 0 R', xmpobj)
   pdf.catalog=meta
end

\end{luacode*}
\endinput

-- Local Variables:
-- lua-indent-level: 2
-- tab-width: 2
-- indent-tabs-mode: nil
-- End:
-- vim:set tabstop=2 expandtab: #
